VST 3 Examples VST 3.7 SDK for developing VST plug-in

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Controller Class Reference

Example Note Expression Edit Controller. More...

`#include <note_expression_synth_controller.h>`

Inheritance diagram for Controller:

## Public Types
enum | NoteExpressionTypeIds { kNoiseVolumeTypeID = kCustomStart, kFilterFreqModTypeID, kFilterQModTypeID, kSinusVolumeTypeID, kTriangleVolumeTypeID, kFilterTypeTypeID, kTriangleSlopeTypeID, kSinusDetuneTypeID, kReleaseTimeModTypeID, kTextInputTypeID, kSquareVolumeTypeID }

## Public Member Functions
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
tresult | terminate () SMTG_OVERRIDE
tresult | setComponentState (IBStream *state) SMTG_OVERRIDE
tresult | setParamNormalized (ParamID tag, ParamValue value) SMTG_OVERRIDE
tresult | getMidiControllerAssignment (int32 busIndex, int16 channel, CtrlNumber midiControllerNumber, ParamID &id) SMTG_OVERRIDE
int32 | getNoteExpressionCount (int32 busIndex, int16 channel) SMTG_OVERRIDE
tresult | getNoteExpressionInfo (int32 busIndex, int16 channel, int32 noteExpressionIndex, NoteExpressionTypeInfo &info) SMTG_OVERRIDE
tresult | getNoteExpressionStringByValue (int32 busIndex, int16 channel, NoteExpressionTypeID id, NoteExpressionValue valueNormalized, String128 string) SMTG_OVERRIDE
tresult | getNoteExpressionValueByString (int32 busIndex, int16 channel, NoteExpressionTypeID id, const TChar *string, NoteExpressionValue &valueNormalized) SMTG_OVERRIDE
tresult | getPhysicalUIMapping (int32 busIndex, int16 channel, PhysicalUIMapList &list) SMTG_OVERRIDE
Public Member Functions inherited from EditController
| EditController ()
tresult | setState (IBStream *state) SMTG_OVERRIDE
tresult | getState (IBStream *state) SMTG_OVERRIDE
int32 | getParameterCount () SMTG_OVERRIDE
tresult | getParameterInfo (int32 paramIndex, ParameterInfo &info) SMTG_OVERRIDE
tresult | getParamStringByValue (ParamID tag, ParamValue valueNormalized, String128 string) SMTG_OVERRIDE
tresult | getParamValueByString (ParamID tag, TChar *string, ParamValue &valueNormalized) SMTG_OVERRIDE
ParamValue | normalizedParamToPlain (ParamID tag, ParamValue valueNormalized) SMTG_OVERRIDE
ParamValue | plainParamToNormalized (ParamID tag, ParamValue plainValue) SMTG_OVERRIDE
ParamValue | getParamNormalized (ParamID tag) SMTG_OVERRIDE
tresult | setComponentHandler (IComponentHandler *handler) SMTG_OVERRIDE
IPlugView * | createView (FIDString) SMTG_OVERRIDE
tresult | setKnobMode (KnobMode mode) SMTG_OVERRIDE
tresult | openHelp (TBool) SMTG_OVERRIDE
tresult | openAboutBox (TBool) SMTG_OVERRIDE
virtual tresult | beginEdit (ParamID tag)
virtual tresult | performEdit (ParamID tag, ParamValue valueNormalized)
virtual tresult | endEdit (ParamID tag)
virtual tresult | startGroupEdit ()
virtual tresult | finishGroupEdit ()
virtual void | editorDestroyed (EditorView *)
virtual void | editorAttached (EditorView *)
virtual void | editorRemoved (EditorView *)
virtual Parameter * | getParameterObject (ParamID tag)
virtual tresult | getParameterInfoByTag (ParamID tag, ParameterInfo &info)
virtual tresult | setDirty (TBool state)
virtual tresult | requestOpenEditor (FIDString name=ViewType::kEditor)
IComponentHandler * | getComponentHandler () const

## Static Public Member Functions
static FUnknown * | createInstance (void *)
Static Public Member Functions inherited from EditController
static KnobMode | getHostKnobMode ()

## Public Attributes
std::array< ParamID, ControllerNumbers::kCountCtrlNumber > | midiCCMapping
Public Attributes inherited from EditController
OBJ_METHODS(EditController, ComponentBase) DEFINE_INTERFACES DEF_INTERFACE(IEditController) DEF_INTERFACE(IEditController2) END_DEFINE_INTERFACES(ComponentBase) REFCOUNT_METHODS(ComponentBase) protected IPtr < IComponentHandler2 > | componentHandler2
ParameterContainer | parameters

## Static Public Attributes
static FUID | cid
static OBJ_METHODS(Controller, EditController) DEFINE_INTERFACES DEF_INTERFACE(INoteExpressionController) DEF_INTERFACE(IMidiMapping) DEF_INTERFACE(INoteExpressionPhysicalUIMapping) END_DEFINE_INTERFACES(EditController) REFCOUNT_METHODS(EditController) protected constexpr ParamID | InvalidParamID = std::numeric_limits<ParamID>::max ()
Static Public Attributes inherited from EditController
static KnobMode | hostKnobMode
Static Public Attributes inherited from IEditController
static const FUID | iid
Static Public Attributes inherited from IPluginBase
static const FUID | iid
Static Public Attributes inherited from FUnknown
static const FUID | iid
Static Public Attributes inherited from IEditController2
static const FUID | iid
Static Public Attributes inherited from INoteExpressionController
static const FUID | iid
Static Public Attributes inherited from IMidiMapping
static const FUID | iid
Static Public Attributes inherited from INoteExpressionPhysicalUIMapping
static const FUID | iid

## Detailed Description

Example Note Expression Edit Controller.

See Also
  Steinberg::Vst::INoteExpressionController
  Steinberg::Vst::NoteExpressionTypeContainer
  Steinberg::Vst::NoteExpressionType

## Member Enumeration Documentation

enum NoteExpressionTypeIds

Enumerator
kNoiseVolumeTypeID |
kFilterFreqModTypeID |
kFilterQModTypeID |
kSinusVolumeTypeID |
kTriangleVolumeTypeID |
kFilterTypeTypeID |
kTriangleSlopeTypeID |
kSinusDetuneTypeID |
kReleaseTimeModTypeID |
kTextInputTypeID |
kSquareVolumeTypeID |

## Member Function Documentation

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Reimplemented from EditController.

Reimplemented in ControllerWithUI.

tresult terminate | ( |  | ) |
| virtual

Reimplemented from EditController.

Reimplemented in ControllerWithUI.

tresult setComponentState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

tresult setParamNormalized | ( | ParamID | tag,
|  | ParamValue | value
| ) |  |
| virtual

Reimplemented from EditController.

tresult getMidiControllerAssignment | ( | int32 | busIndex,
|  | int16 | channel,
|  | CtrlNumber | midiControllerNumber,
|  | ParamID & | id
| ) |  |
| virtual

Implements IMidiMapping.

int32 getNoteExpressionCount | ( | int32 | busIndex,
|  | int16 | channel
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionInfo | ( | int32 | busIndex,
|  | int16 | channel,
|  | int32 | noteExpressionIndex,
|  | NoteExpressionTypeInfo & | info
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionStringByValue | ( | int32 | busIndex,
|  | int16 | channel,
|  | NoteExpressionTypeID | id,
|  | NoteExpressionValue | valueNormalized,
|  | String128 | string
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionValueByString | ( | int32 | busIndex,
|  | int16 | channel,
|  | NoteExpressionTypeID | id,
|  | const TChar * | string,
|  | NoteExpressionValue & | valueNormalized
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getPhysicalUIMapping | ( | int32 | busIndex,
|  | int16 | channel,
|  | PhysicalUIMapList & | list
| ) |  |
| virtual

Implements INoteExpressionPhysicalUIMapping.

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

## Member Data Documentation

FUID cid
| static

OBJ_METHODS (Controller, EditController) DEFINE_INTERFACES DEF_INTERFACE (INoteExpressionController) DEF_INTERFACE (IMidiMapping) DEF_INTERFACE (INoteExpressionPhysicalUIMapping) END_DEFINE_INTERFACES (EditController) REFCOUNT_METHODS (EditController) protected constexpr ParamID InvalidParamID = std::numeric_limits<ParamID>::max ()
| static

std::array<ParamID, ControllerNumbers::kCountCtrlNumber> midiCCMapping

Empty

Copyright ©2024 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.